﻿using PuppeteerSharp;
using System;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;

var browser = await Puppeteer.LaunchAsync(new LaunchOptions
{
    Headless = true,
    SlowMo = 40,
    ExecutablePath = @"C:\Program Files (x86)\Microsoft\Edge\Application\msedge.exe"
});
var page = await browser.NewPageAsync();
var userAgent = await browser.GetUserAgentAsync();
await page.SetUserAgentAsync($"{userAgent} TestBot");

// statt der nachfolgenden Zeile könnte für Tests die HTML-Datei auch mit den folgenden drei
// auskommentierten Zeilen geladen werden
 await page.GoToAsync("https://www.janschreier.de/Fallzahlen1.html");
//using var streamReader = new StreamReader(@"Fallzahlen1.html", Encoding.UTF8);
//var webPage = streamReader.ReadToEnd();
//await page.SetContentAsync(webPage);
string[] paragraphs = await page
                    .EvaluateExpressionAsync<string[]>(@"Array.from(document.querySelectorAll('p')).map(p => p.innerText)");

// Ab hier erfolgt die Evaluation unabhängig von PuppeteerSharp
var datumRegex = new Regex(@"Datenstand: (\d{1,2}\.\d{2}\.202[1,2])");
var datumText = FindFirstRegexInStringArray(paragraphs, datumRegex);

if (datumText == null)
{
    Console.WriteLine("Abbruch! Datum nicht gefunden");
}
else
{
    var neueFaelleRegex = new Regex(@"(\d*) weitere Fälle");
    var neueFaelle = FindFirstRegexInStringArray(paragraphs, neueFaelleRegex);
    Console.WriteLine($"{datumText} : {neueFaelle ?? "neue Fälle nicht gefunden"}");

    var inzidenzRegex = new Regex(@"7-Tages-Inzidenz beträgt (\d{1,4},\d{0,2})\.");
    var inzidenz = FindFirstRegexInStringArray(paragraphs, inzidenzRegex);
    Console.WriteLine($"{datumText} : {inzidenz ?? "Inzidenz nicht gefunden"}");
}

static string? FindFirstRegexInStringArray(string[] paragraphs, Regex regex)
{
    foreach (string paragraph in paragraphs)
    {
        var regexMatch = regex.Match(paragraph);
        if (regexMatch.Success)
        {
            return regexMatch.Groups[1].ToString();
        }
    }
    return null;
}
